import { CdkConnectedOverlay, CdkOverlayOrigin } from '@angular/cdk/overlay';
import { AfterViewInit, EventEmitter, OnDestroy, OnInit } from '@angular/core';
import { ControlValueAccessor } from '@angular/forms';
import { AtOptionContainerComponent } from './at-option-container.component';
import { AtOptionComponent } from './at-option.component';
import { TFilterOption } from './at-option.pipe';
import { AtSelectControlService } from './at-select-control.service';
import { AtSelectTopControlComponent } from './at-select-top-control.component';
export declare class AtSelectComponent implements ControlValueAccessor, OnInit, AfterViewInit, OnDestroy {
    at_select_control_service: AtSelectControlService;
    atValue: any[];
    ngOnDestroy(): void;
    registerOnChange(fn: (_: any) => {}): void;
    registerOnTouched(fn: () => {}): void;
    setDisabledState(isDisabled: boolean): void;
    writeValue(obj: string | string[]): void;
    onChange: (value: string | string[]) => void;
    onTouched: () => void;
    dropDownPosition: 'top' | 'center' | 'bottom' | 'hidden';
    listOfSelectedValue: any[];
    listOfTemplateOption: AtOptionComponent[];
    value: any | any[];
    overlayWidth: number;
    overlayMinWidth: number;
    searchValue: string;
    dropDownClassMap: any;
    cdkOverlayOrigin: CdkOverlayOrigin;
    cdkConnectedOverlay: CdkConnectedOverlay;
    atSelectTopControlComponent: AtSelectTopControlComponent;
    atOptionContainerComponent: AtOptionContainerComponent;
    /** should move to at-option-container when https://github.com/angular/angular/issues/20810 resolved **/
    readonly search: EventEmitter<string>;
    readonly atScrollToBottom: EventEmitter<void>;
    readonly atOpenChange: EventEmitter<boolean>;
    atSize: string;
    atServerSearch: boolean;
    _atMode: 'default' | 'multiple' | 'tags';
    atDropdownMatchSelectWidth: boolean;
    atFilterOption: TFilterOption;
    atMaxMultipleCount: number;
    atDropdownStyle: {
        [key: string]: string;
    };
    atNotFoundContent: string;
    compareWith: (o1: any, o2: any) => boolean;
    atPlaceHolder: any;
    searchable: boolean;
    multiple: boolean;
    allowClear: boolean;
    tagAble: boolean;
    atDisabled: boolean;
    atOpen: boolean;
    atMode: 'default' | 'multiple' | 'tags';
    ngOnInit(): void;
    subOpenStatus(): void;
    subClickSelect(): void;
    scrollBottom(): void;
    ngAfterViewInit(): void;
    close(): void;
    constructor(at_select_control_service: AtSelectControlService);
    updateCdkConnectedOverlayStatus(): void;
}
